/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import java.io.IOException;
import java.io.PrintWriter;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.util.Enumeration;
import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Observable;
import java.util.Observer;
import javax.servlet.ServletContext;
import javax.servlet.ServletOutputStream;
import org.apache.tomcat.util.http.fileupload.FileItem;
import org.apache.tomcat.util.http.fileupload.FileItemFactory;
import org.apache.tomcat.util.http.fileupload.FileUploadException;
import org.apache.tomcat.util.http.fileupload.disk.DiskFileItemFactory;
import org.apache.tomcat.util.http.fileupload.servlet.ServletFileUpload;

/**
 *
 * @author khetho
 */
class Conference {

    public int roomNumber;
    public ArrayList<String> clientList;
     private MessageSource source = new MessageSource ();
    public String getNextMessage() {
        // Create a message sink to wait for a new message from the
        // message source.
        return new MessageSink().getNextMessage(source);
    }
     public void broadcastMessage(String message) {
        // Send the message to all the HTTP-connected clients by giving the
        // message to the message source
        if (source == null){
            source = new MessageSource ();
        }
        source.sendMessage(message);
    }
    
}

@WebServlet(name = "PresentationServlet", urlPatterns = {"/PresentationServlet"})
public class PresentationServlet extends HttpServlet {

    
    private ArrayList<Conference> conferenceList;
    
    private int ImageSize;
    String connectionType;
    String username;
    int roomNumber;
   
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException, FileUploadException {
         response.setContentType("text/html;charset=UTF-8");
         
       try {
            System.out.println("Servlet says: This is working after all");
            connectionType = request.getParameter("connectionType");
            username = request.getParameter("name");
            roomNumber = Integer.parseInt(request.getParameter("id"));
            System.out.println("Connection type: " + connectionType);
            if (connectionType.equalsIgnoreCase("Enter")){
            Entering(request,response);
            }
            else if (connectionType.equalsIgnoreCase("Receive"))
                    {
            Retrieve(request,response);
                    }
                    else if(connectionType.equalsIgnoreCase("Presentation")){
            receiveFile(request,response);
                    }
                    else if(connectionType.equalsIgnoreCase("PresentationPresented"))
                    {
                      ReceiveImageId(request,response);   
                    }
                    else if(connectionType.equalsIgnoreCase("ReceiveImageId"))
                    {
                      SendImageId(request,response);    
                    }

         }
        finally {
        }
    }
    
    public void ReceiveImageId(HttpServletRequest request, HttpServletResponse response) throws IOException{
        
      
        System.out.println("In ReceiveImageId");
        String w =request.getParameter("ImageId");
        System.out.println("receivedId: "+w);
         for(Conference conf : conferenceList){
                      if(conf.roomNumber == roomNumber){
                       if(w!=null)
                       
                            conf.broadcastMessage(w);
                           
                            response.setStatus(response.SC_NO_CONTENT);
                          
                       break;
                      }
                 }
               
        
    }
    public void SendImageId(HttpServletRequest request, HttpServletResponse response) throws IOException
    {
                 PrintWriter out= response.getWriter();
                System.out.println("In sendImageId");
                for(Conference conf : conferenceList){
                      if(conf.roomNumber == roomNumber){
                          response.setContentType("text/plain");
                         
                          out.print(conf.getNextMessage());
                           break;
                      }
                 }        
                  out.close();
    }
      public void Entering(HttpServletRequest request, HttpServletResponse response) throws IOException{
                //PrintWriter out= response.getWriter();
                System.out.println("In Enter");
                if (conferenceList == null) {
                  //  out.println("Conference List is nil");
                    conferenceList = new ArrayList<Conference>();
                } else {
                    //out.println("Number of conferences: " + conferenceList.size());
                }

                boolean conferenceExists = false;
                for (Conference conf : conferenceList) {
                    if (conf.roomNumber == roomNumber) {
                        conferenceExists = true;
                        boolean userExists = false;
                        for (String name : conf.clientList) {
                            //out.println("Connected users:");
                            //out.println(name);
                            if (name.equals(username)) {
                                userExists = true;
                                break;
                            }
                        }
                        if (!userExists) {
                            //out.println("Add a new user name: " + username + " to conference: " + conf.roomNumber);
                            conf.clientList.add(username);
                        }
                        break;
                    }
                }
                if (!conferenceExists) {
                   
                    //out.println("Add a new conference number: " + roomNumber);
                    Conference newConf = new Conference();
                    newConf.clientList = new ArrayList<String>();
                    newConf.roomNumber = roomNumber;

                    //out.println("Add a new user name: " + username + " to conference: " + newConf.roomNumber);
                    newConf.clientList.add(username);
                    conferenceList.add(newConf);

                    //out.println("Number of conferences: " + conferenceList.size());
                }
                //out.close();
            }
        
           public void Retrieve(HttpServletRequest request, HttpServletResponse response){
                System.out.println("In Recieve");
                response.setContentType("image/jpeg");
                ArrayList<byte[]> allImages;
                
                if (this.getServletConfig().getServletContext().getAttribute("" + roomNumber) == null) {
                    allImages = new ArrayList<byte[]>();
                } else {
                    allImages = (ArrayList<byte[]>) this.getServletConfig().getServletContext().getAttribute("" + roomNumber);
                }

                try {
                    OutputStream output = response.getOutputStream();
                    ObjectOutputStream os = new ObjectOutputStream(output);
                    os.writeObject(allImages);
                    os.flush();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            } 
                 
          public void receiveFile(HttpServletRequest request, HttpServletResponse response) throws FileUploadException, IOException{  
                System.out.println("In Presentation");
                ServletFileUpload upload = new ServletFileUpload(new DiskFileItemFactory());
                List<FileItem> items = upload.parseRequest(request);
                ImageSize = Integer.parseInt(request.getParameter("size"));

                for (FileItem item : items) {

                    if (!item.isFormField()) {

                        InputStream in = item.getInputStream();

                        byte[] imagebytearray = new byte[ImageSize];

                        in.read(imagebytearray, 0, ImageSize);

                        ArrayList<byte[]> allImages = new ArrayList<byte[]>();

                        if (this.getServletConfig().getServletContext().getAttribute("" + roomNumber) == null) {
                            // there is nothing into the shared memory
                            allImages.add(imagebytearray);
                            this.getServletConfig().getServletContext().setAttribute("" + roomNumber, allImages);
                        } else {
                            // there is something into the shared memory
                            allImages = (ArrayList<byte[]>) this.getServletConfig().getServletContext().getAttribute("" + roomNumber);
                            allImages.add(imagebytearray);
                            this.getServletConfig().getServletContext().setAttribute("" + roomNumber, allImages);
                        }
                    }
             
                System.out.println("End of saving presentation into the shared memory");
              }
            }
        
    

// <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (FileUploadException ex) {
            Logger.getLogger(PresentationServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        try {
            processRequest(request, response);
        } catch (FileUploadException ex) {
            Logger.getLogger(PresentationServlet.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}

class MessageSource extends Observable {
  public void sendMessage(String message) {
    setChanged();
    notifyObservers(message);
  }
}

// MessageSink acts as the receiver of new messages.
// It listens to the source.
class MessageSink implements Observer {

  String message = null;  // set by update() and read by getNexImage()

  // Called by the message source when it gets a new message
  synchronized public void update(Observable o, Object arg) {
    // Get the new message
    message = (String)arg;
   
    // Wake up our waiting thread
    notify();
  }

  // Gets the next message sent out from the message source
  synchronized public String getNextMessage(MessageSource source) {
    // Tell source we want to be told about new messages
    source.addObserver(this);

    // Wait until our update() method receives a message
    while (message == null) {
      try { wait(); } catch (Exception ignored) { }
    }

    // Tell source to stop telling us about new messages
    source.deleteObserver(this);

    // Now return the message we received
    // But first set the message instance variable to null
    // so update() and getNexImage() can be called again.
    String messageCopy = message;
    message = null;
    return messageCopy;
  }
}


